#!/usr/bin/env python

# Written by Bram Cohen and Myers Carpenter
# Modifications by various people
# see LICENSE.txt for license information

from sys import argv, version
assert version >= '2', "Install Python 2.0 or greater"

from BitTorrent.download import *
from BitTorrent.ConnChoice import *
from BitTorrent.ConfigReader import *
from threading import Event, Thread
from os.path import *
from os import getcwd
from wxPython.wx import *
from time import strftime, time
from webbrowser import open_new
import re
import sys, os
from BitTorrent import version
true = 1
false = 0


basepath=os.path.abspath(os.path.dirname(sys.argv[0]))


def hours(n):
    if n == -1:
        return '<unknown>'
    if n == 0:
        return 'complete!'
    n = int(n)
    h, r = divmod(n, 60 * 60)
    m, sec = divmod(r, 60)
    if h > 1000000:
        return '<unknown>'
    if h > 0:
        return '%d hour(s) %02d min %02d sec' % (h, m, sec)
    else:
        return '%d min %02d sec' % (m, sec)

def size_format(s):
    if (s < 1024):
        r = str(s) + 'B'
    elif (s < 1048576):
        r = str(int(s/1024)) + 'KiB'
    elif (s < 1073741824L):
        r = str(int(s/1048576)) + 'MiB'
    elif (s < 1099511627776L):
        r = str(int((s/1073741824.0)*100.0)/100.0) + 'GiB'
    else:
        r = str(int((s/1099511627776.0)*100.0)/100.0) + 'TiB'
    return(r)

def comma_format(s):
    r = str(s)
    for i in range(len(r)-3, 0, -3):
        r = r[:i]+','+r[i:]
    return(r)

wxEVT_INVOKE = wxNewEventType()

def EVT_INVOKE(win, func):
    win.Connect(-1, -1, wxEVT_INVOKE, func)

class InvokeEvent(wxPyEvent):
    def __init__(self, func, args, kwargs):
        wxPyEvent.__init__(self)
        self.SetEventType(wxEVT_INVOKE)
        self.func = func
        self.args = args
        self.kwargs = kwargs

def pr(event):
    print 'augh!'



class DownloadInfoFrame:
    def __init__(self, flag):
        DownloadInfoFrameSelf = self
        frame = wxFrame(None, -1, 'BitTorrent ' + version + ' download')
        self.aaa = 0
        self.flag = flag
        self.uiflag = Event()
        self.fin = false
        self.aboutBox = None
        self.detailBox = None
        self.advBox = None
        self.creditsBox = None
        self.statusIconHelpBox = None
        self.reannouncelast = 0
        self.spinlock = 0
        self.scrollock = 0
        self.lastError = 0
        self.spewwait = time()
        self.config = None
        self.updateSpinnerFlag = 0
        self.updateSliderFlag = 0
        self.statusIconValue = ' '
        self.iconized = 0
        self.checking = None
        self.activity = 'Starting up...'
        self.firstupdate = true
        self.shuttingdown = false
        self.ispaused = false
        self.bgalloc_periods = 0
        self.gui_lastupdate = time()

        if (sys.platform == 'win32'):
            self.icon = wxIcon(os.path.join(basepath,'icon_bt.ico'), wxBITMAP_TYPE_ICO)
        self.starttime = time ()

        self.frame = frame
        if (sys.platform == 'win32'):
            self.frame.SetIcon(self.icon)

        panel = wxPanel(frame, -1)
        colSizer = wxFlexGridSizer(cols = 1, vgap = 3)
        colSizer.AddGrowableCol (0)
        colSizer.AddGrowableRow (6)

        border = wxBoxSizer(wxHORIZONTAL)
        border.Add(colSizer, 1, wxEXPAND | wxALL, 4)
        panel.SetSizer(border)
        panel.SetAutoLayout(true)

        topboxsizer = wxFlexGridSizer(cols = 3, vgap = 0)
        topboxsizer.AddGrowableCol (0)

        fnsizer = wxFlexGridSizer(cols = 1, vgap = 0)
        fnsizer.AddGrowableCol (0)
        fnsizer.AddGrowableRow (1)

        fileNameText = wxStaticText(panel, -1, '', style = wxALIGN_LEFT)
        fileNameText.SetFont(wxFont(12, wxDEFAULT, wxNORMAL, wxNORMAL, false))
        fnsizer.Add(fileNameText, 1, wxALIGN_BOTTOM|wxEXPAND)
        self.fileNameText = fileNameText

        fnsizer2 = wxFlexGridSizer(cols = 8, vgap = 0)
        fnsizer2.AddGrowableCol (0)

        fileSizeText = wxStaticText(panel, -1, '', style = wxALIGN_LEFT)
        fileSizeText.SetFont(wxFont(10, wxDEFAULT, wxNORMAL, wxNORMAL, false))
        fnsizer2.Add(fileSizeText, 1, wxALIGN_BOTTOM|wxEXPAND)
        self.fileSizeText = fileSizeText

        fileDetails = wxStaticText(panel, -1, 'Details', style = wxALIGN_RIGHT)
        fileDetails.SetFont(wxFont(-1, wxDEFAULT, wxNORMAL, wxNORMAL, true))
        fileDetails.SetForegroundColour('Blue')
        fnsizer2.Add(fileDetails, 0, wxALIGN_BOTTOM)                                     

        fnspacer = wxStaticText(panel, -1, '  ', style = wxALIGN_RIGHT)
#        fnspacer.SetFont(wxFont(10, wxDEFAULT, wxNORMAL, wxNORMAL, true))
        fnsizer2.Add(fnspacer)

        advText = wxStaticText(panel, -1, 'Advanced', style = wxALIGN_RIGHT)
        advText.SetForegroundColour('Blue')
        advText.SetFont(wxFont(-1, wxDEFAULT, wxNORMAL, wxNORMAL, true))
        fnsizer2.Add(advText, 0, wxALIGN_BOTTOM)
        fnsizer2.Add(fnspacer)

        prefsText = wxStaticText(panel, -1, 'Prefs', style = wxALIGN_RIGHT)
        prefsText.SetForegroundColour('Blue')
        prefsText.SetFont(wxFont(-1, wxDEFAULT, wxNORMAL, wxNORMAL, true))
        fnsizer2.Add(prefsText, 0, wxALIGN_BOTTOM)
        fnsizer2.Add(fnspacer)

        aboutText = wxStaticText(panel, -1, 'About', style = wxALIGN_RIGHT)
        aboutText.SetForegroundColour('Blue')
        aboutText.SetFont(wxFont(-1, wxDEFAULT, wxNORMAL, wxNORMAL, true))
        fnsizer2.Add(aboutText, 0, wxALIGN_BOTTOM)

        fnsizer2.Add(fnspacer)
        fnsizer.Add(fnsizer2,0,wxEXPAND)
        topboxsizer.Add(fnsizer,0,wxEXPAND)
        topboxsizer.Add(wxStaticText(panel, -1, '  ', style = wxALIGN_RIGHT))

        wxInitAllImageHandlers()
        self.statusIcons={
            'startup':wxIcon(os.path.join(basepath,'white.ico'), wxBITMAP_TYPE_ICO),
            'disconnected':wxIcon(os.path.join(basepath,'black.ico'), wxBITMAP_TYPE_ICO),
            'noconnections':wxIcon(os.path.join(basepath,'red.ico'), wxBITMAP_TYPE_ICO),
            'nocompletes':wxIcon(os.path.join(basepath,'blue.ico'), wxBITMAP_TYPE_ICO),
            'noincoming':wxIcon(os.path.join(basepath,'yellow.ico'), wxBITMAP_TYPE_ICO),
            'allgood':wxIcon(os.path.join(basepath,'green.ico'), wxBITMAP_TYPE_ICO)
            }

        self.statusIcon = wxEmptyBitmap(32,32)
        statidata = wxMemoryDC()
        statidata.SelectObject(self.statusIcon)
        statidata.SetPen(wxTRANSPARENT_PEN)
        statidata.SetBrush(wxBrush(wx.wxSystemSettings_GetColour(wxSYS_COLOUR_MENU),wxSOLID))
        statidata.DrawRectangle(0,0,32,32)
        self.statusIconPtr = wxStaticBitmap(panel, -1, self.statusIcon)
        topboxsizer.Add(self.statusIconPtr)
        

        self.fnsizer = fnsizer
        self.fnsizer2 = fnsizer2
        self.topboxsizer = topboxsizer
        self.fnspacer = fnspacer
        colSizer.Add(topboxsizer, 0, wxEXPAND)

        self.gauge = wxGauge(panel, -1, range = 1000, style = wxGA_SMOOTH)
        colSizer.Add(self.gauge, 0, wxEXPAND)
#        self.gauge.SetForegroundColour(wx.wxSystemSettings_GetColour(wxSYS_COLOUR_3DSHADOW))

        timeSizer = wxFlexGridSizer(cols = 2)
        timeSizer.Add(wxStaticText(panel, -1, 'Time elapsed / estimated : '))
        self.timeText = wxStaticText(panel, -1, self.activity+'                    ')
        timeSizer.Add(self.timeText)
        timeSizer.AddGrowableCol(1)
        colSizer.Add(timeSizer)

        destSizer = wxFlexGridSizer(cols = 2, hgap = 8)
        self.fileDestLabel = wxStaticText(panel, -1, 'Download to:')
        destSizer.Add(self.fileDestLabel)
        self.fileDestText = wxStaticText(panel, -1, '')
        destSizer.Add(self.fileDestText, flag = wxEXPAND)
        destSizer.AddGrowableCol(1)
        colSizer.Add(destSizer, flag = wxEXPAND)
        self.destSizer = destSizer

        statSizer = wxFlexGridSizer(cols = 3, hgap = 8)

        self.ratesSizer = wxFlexGridSizer(cols = 2)
        self.infoSizer = wxFlexGridSizer(cols = 2)

        self.ratesSizer.Add(wxStaticText(panel, -1, '   Download rate: '))
        self.downRateText = wxStaticText(panel, -1, '   0 kB/s')
        self.ratesSizer.Add(self.downRateText, flag = wxEXPAND)

        self.downTextLabel = wxStaticText(panel, -1, 'Downloaded: ')
        self.infoSizer.Add(self.downTextLabel)
        self.downText = wxStaticText(panel, -1, '    0.00 MiB')
        self.infoSizer.Add(self.downText, flag = wxEXPAND)

        self.ratesSizer.Add(wxStaticText(panel, -1, '   Upload rate: '))
        self.upRateText = wxStaticText(panel, -1, '   0 kB/s')
        self.ratesSizer.Add(self.upRateText, flag = wxEXPAND)

        self.upTextLabel = wxStaticText(panel, -1, 'Uploaded: ')
        self.infoSizer.Add(self.upTextLabel)
        self.upText = wxStaticText(panel, -1, '    0.00 MiB')
        self.infoSizer.Add(self.upText, flag = wxEXPAND)

        shareSizer = wxFlexGridSizer(cols = 2, hgap = 8)
        shareSizer.Add(wxStaticText(panel, -1, 'Share rating:'))
        self.shareRatingText = wxStaticText(panel, -1, '')
        shareSizer.AddGrowableCol(1)
        shareSizer.Add(self.shareRatingText, flag = wxEXPAND)

        statSizer.Add(self.ratesSizer)
        statSizer.Add(self.infoSizer)
        statSizer.Add(shareSizer, flag = wxALIGN_CENTER_VERTICAL)
        colSizer.Add (statSizer)

        torrentSizer = wxFlexGridSizer(cols = 1)
        self.peerStatusText = wxStaticText(panel, -1, '')
        torrentSizer.Add(self.peerStatusText, 0, wxEXPAND)
        self.seedStatusText = wxStaticText(panel, -1, '')
        torrentSizer.Add(self.seedStatusText, 0, wxEXPAND)
        torrentSizer.AddGrowableCol(0)
        colSizer.Add(torrentSizer, 0, wxEXPAND)
        self.torrentSizer = torrentSizer

        self.errorTextSizer = wxFlexGridSizer(cols = 1)
        self.errorText = wxStaticText(panel, -1, '', style = wxALIGN_LEFT)
        self.errorText.SetForegroundColour('Red')
        self.errorTextSizer.Add(self.errorText, 0, wxEXPAND)
        colSizer.Add(self.errorTextSizer, 0, wxEXPAND)

        cancelSizer=wxGridSizer(cols = 2, hgap = 40)
        self.pauseButton = wxButton(panel, -1, 'Pause')
        cancelSizer.Add(self.pauseButton, 0, wxALIGN_CENTER)

        self.cancelButton = wxButton(panel, -1, 'Cancel')
        cancelSizer.Add(self.cancelButton, 0, wxALIGN_CENTER)
        colSizer.Add(cancelSizer, 0, wxALIGN_CENTER)

        # Setting options

        slideSizer = wxFlexGridSizer(cols = 7, hgap = 0, vgap = 5)

        # dropdown

        self.connChoiceLabel = wxStaticText(panel, -1, 'Settings for ')
        slideSizer.Add (self.connChoiceLabel, 0, wxALIGN_LEFT|wxALIGN_CENTER_VERTICAL)
        self.connChoice = wxChoice (panel, -1, (-1, -1), (90, -1), choices = connChoiceList)
        self.connChoice.SetSelection(0)
        slideSizer.Add (self.connChoice, 0, wxALIGN_CENTER)
        self.rateSpinnerLabel = wxStaticText(panel, -1, ' Upload rate (kB/s) ')
        slideSizer.Add (self.rateSpinnerLabel, 0, wxALIGN_RIGHT|wxALIGN_CENTER_VERTICAL)

        # max upload rate

        self.rateSpinner = wxSpinCtrl (panel, -1, "", (-1,-1), (50, -1))
        self.rateSpinner.SetRange(0,5000)
        self.rateSpinner.SetValue(0)
        slideSizer.Add (self.rateSpinner, 0, wxALIGN_CENTER|wxALIGN_CENTER_VERTICAL)

        self.rateLowerText = wxStaticText(panel, -1, '  %5d' % (0))
        self.rateUpperText = wxStaticText(panel, -1, '%5d' % (5000))
        self.rateslider = wxSlider(panel, -1, 0, 0, 5000, (-1, -1), (80, -1))

        slideSizer.Add(self.rateLowerText, 0, wxALIGN_RIGHT|wxALIGN_CENTER_VERTICAL)
        slideSizer.Add(self.rateslider,    0, wxALIGN_CENTER|wxALIGN_CENTER_VERTICAL)
        slideSizer.Add(self.rateUpperText, 0, wxALIGN_LEFT|wxALIGN_CENTER_VERTICAL)

        slideSizer.Add(wxStaticText(panel, -1, ''), 0, wxALIGN_LEFT)

        self.bgallocText = wxStaticText(panel, -1, '', style = wxALIGN_LEFT)
        self.bgallocText.SetForegroundColour('Red')
        slideSizer.Add(self.bgallocText, 0, wxALIGN_LEFT)

        # max uploads

        self.connSpinnerLabel = wxStaticText(panel, -1, ' Max uploads ')
        slideSizer.Add (self.connSpinnerLabel, 0, wxALIGN_RIGHT|wxALIGN_CENTER_VERTICAL)
        self.connSpinner = wxSpinCtrl (panel, -1, "", (-1,-1), (50, -1))
        self.connSpinner.SetRange(4,100)
        self.connSpinner.SetValue(4)
        slideSizer.Add (self.connSpinner, 0, wxALIGN_CENTER|wxALIGN_CENTER_VERTICAL)

        self.connLowerText = wxStaticText(panel, -1, '  %5d' % (4))
        self.connUpperText = wxStaticText(panel, -1, '%5d' % (100))
        self.connslider = wxSlider(panel, -1, 4, 4, 100, (-1, -1), (80, -1))

        slideSizer.Add(self.connLowerText, 0, wxALIGN_RIGHT|wxALIGN_CENTER_VERTICAL)
        slideSizer.Add(self.connslider,    0, wxALIGN_CENTER|wxALIGN_CENTER_VERTICAL)
        slideSizer.Add(self.connUpperText, 0, wxALIGN_LEFT|wxALIGN_CENTER_VERTICAL)

        colSizer.Add(slideSizer, 1, wxALL|wxALIGN_CENTER|wxEXPAND, 0)

        self.unlimitedLabel = wxStaticText(panel, -1, '0 kB/s means unlimited. Tip: your download rate is proportional to your upload rate')
        self.unlimitedLabel.SetFont(wxFont(7, wxDEFAULT, wxNORMAL, wxNORMAL, false))
        colSizer.Add(self.unlimitedLabel, 0, wxALIGN_CENTER)

        EVT_LEFT_DOWN(aboutText, self.about)
        EVT_LEFT_DOWN(fileDetails, self.details)
        EVT_LEFT_DOWN(self.statusIconPtr,self.statusIconHelp)
        EVT_LEFT_DOWN(advText, self.advanced)
        EVT_LEFT_DOWN(prefsText, self.openConfigMenu)
        EVT_CLOSE(frame, self.done)
        EVT_BUTTON(frame, self.pauseButton.GetId(), self.pause)
        EVT_BUTTON(frame, self.cancelButton.GetId(), self.done)
        EVT_INVOKE(frame, self.onInvoke)
        EVT_SCROLL(self.rateslider, self.onRateScroll)
        EVT_SCROLL(self.connslider, self.onConnScroll)
        EVT_CHOICE(self.connChoice, -1, self.onConnChoice)
        EVT_SPINCTRL(self.connSpinner, -1, self.onConnSpinner)
        EVT_SPINCTRL(self.rateSpinner, -1, self.onRateSpinner)
        if (sys.platform == 'win32'):
            EVT_ICONIZE(self.frame, self.onIconify)

        self.frame.Show()
        border.Fit(panel)
        self.frame.Fit()
        self.panel = panel
        self.border = border
        self.addwidth = aboutText.GetBestSize().GetWidth() + fileDetails.GetBestSize().GetWidth() + fnspacer.GetBestSize().GetWidth() + 100
        self.fnsizer = fnsizer
        self.colSizer = colSizer
        minsize = self.colSizer.GetSize()
        minsize.SetWidth (minsize.GetWidth())
        minsize.SetHeight (minsize.GetHeight())
        self.colSizer.SetMinSize (minsize)
        self.colSizer.Fit(self.frame)
        colSizer.Fit(frame)



    def setStatusIcon(self, name):
        if name != self.statusIconValue:
            self.statusIconValue = name;
            statidata = wxMemoryDC()
            statidata.SelectObject(self.statusIcon)
            statidata.BeginDrawing()
            statidata.DrawIcon(self.statusIcons[name],0,0)
            statidata.EndDrawing()
            statidata.SelectObject(wxNullBitmap)
            self.statusIconPtr.Refresh()
        return


    def createStatusIcon(self, name):
        iconbuffer = wxEmptyBitmap(32,32)
        bbdata = wxMemoryDC()
        bbdata.SelectObject(iconbuffer)
        bbdata.SetPen(wxTRANSPARENT_PEN)
        bbdata.SetBrush(wxBrush(wx.wxSystemSettings_GetColour(wxSYS_COLOUR_MENU),wxSOLID))
        bbdata.DrawRectangle(0,0,32,32)
        bbdata.DrawIcon(self.statusIcons[name],0,0)
        return iconbuffer


    def onIconify(self, evt):
        if self.configfile.configfileargs['win32_taskbar_icon']:
            if not hasattr(self.frame, "tbicon"):
                self.frame.tbicon = wxTaskBarIcon()
                self.frame.tbicon.SetIcon(self.icon, "BitTorrent")
                # setup a taskbar icon, and catch some events from it
                EVT_TASKBAR_LEFT_DCLICK(self.frame.tbicon, self.onTaskBarActivate)
                EVT_TASKBAR_RIGHT_UP(self.frame.tbicon, self.onTaskBarMenu)
                EVT_MENU(self.frame.tbicon, self.TBMENU_RESTORE, self.onTaskBarActivate)
                EVT_MENU(self.frame.tbicon, self.TBMENU_CLOSE, self.done)
            self.frame.Hide()
        else:
            EVT_ICONIZE(self.frame, self.onIconifyDummy)
            if self.iconized:
                self.frame.Iconize(false)
                self.iconized = false
            else:
                self.frame.Iconize(true)
                self.iconized = true
            EVT_ICONIZE(self.frame, self.onIconify)
            # rant here -- why in god's name can't a function called by an event
            # trigger the event without calling itself?
            # self.frame.Iconize(not self.frame.IsIconized()) should do this job...

        return

    def onIconifyDummy(self, evt):
        return

    def onTaskBarActivate(self, evt):
        if self.frame.IsIconized():
            self.frame.Iconize(false)
        if not self.frame.IsShown():
            self.frame.Show(true)
            self.frame.Raise()
        if hasattr(self.frame, "tbicon"):
            del self.frame.tbicon
        return

    TBMENU_RESTORE = 1000
    TBMENU_CLOSE   = 1001

    def onTaskBarMenu(self, evt):
        menu = wxMenu()
        menu.Append(self.TBMENU_RESTORE, "Restore BitTorrent")
        menu.Append(self.TBMENU_CLOSE,   "Close")
        self.frame.tbicon.PopupMenu(menu)
        menu.Destroy()

    def onRateScroll(self, event):
      if (self.scrollock == 0):
        self.scrollock = 1
        if self.config is None:
            self.config = self.dow.getConfig()
        self.config['max_upload_rate'] = (self.rateslider.GetValue() * 1000
                    * connChoices[self.connChoice.GetSelection()]['rate'].get('div',1))
        self.updateSpinnerFlag = 1
        self.dow.setUploadRate()
        self.scrollock = 0

    def onConnScroll(self, event):
        if self.config is None:
            self.config = self.dow.getConfig()
        self.connSpinner.SetValue (self.connslider.GetValue ())
        self.config['max_uploads'] = self.connslider.GetValue ()
        if (self.connSpinner.GetValue() > 30):
            self.config['max_initiate'] = self.connslider.GetValue () + 10

    def onRateSpinner(self, event):
      if self.config is None:
          self.config = self.dow.getConfig()
      if (self.spinlock == 0):
        self.spinlock = 1
        spinnerValue = self.rateSpinner.GetValue()
        div = connChoices[self.connChoice.GetSelection()]['rate'].get('div',1)
        if div > 1:
            if spinnerValue > (self.config['max_upload_rate']/1000):
                round_up = div - 1
            else:
                round_up = 0
            newValue = int((spinnerValue + round_up) / div) * div
            if newValue != spinnerValue:
                self.rateSpinner.SetValue(newValue)
        else:
            newValue = spinnerValue
        self.config['max_upload_rate'] = newValue * 1000
        self.dow.setUploadRate()
        self.updateSliderFlag = 1
        self.spinlock = 0

    def onConnSpinner(self, event):
        if self.config is None:
            self.config = self.dow.getConfig()
        self.connslider.SetValue (self.connSpinner.GetValue())
        self.config['max_uploads'] = self.connSpinner.GetValue()
        if (self.connSpinner.GetValue() > 30):
            self.config['max_initiate'] = self.connSpinner.GetValue() + 10

    def onConnChoice(self, event):
        if self.config is None:
            self.config = self.dow.getConfig()
        num = self.connChoice.GetSelection()
        self.rateSpinner.SetRange (connChoices[num]['rate']['min'],
                               connChoices[num]['rate']['max'])
        self.rateSpinner.SetValue (connChoices[num]['rate']['def'])
        self.rateslider.SetRange (
            connChoices[num]['rate']['min']/connChoices[num]['rate'].get('div',1),
            connChoices[num]['rate']['max']/connChoices[num]['rate'].get('div',1))
        self.rateslider.SetValue (
            connChoices[num]['rate']['def']/connChoices[num]['rate'].get('div',1))
        self.rateLowerText.SetLabel ('  %d' % (connChoices[num]['rate']['min']))
        self.rateUpperText.SetLabel ('%d' % (connChoices[num]['rate']['max']))
        self.connSpinner.SetRange (connChoices[num]['conn']['min'],
                                   connChoices[num]['conn']['max'])
        self.connSpinner.SetValue (connChoices[num]['conn']['def'])
        self.connslider.SetRange (connChoices[num]['conn']['min'],
                                  connChoices[num]['conn']['max'])
        self.connslider.SetValue (connChoices[num]['conn']['def'])
        self.connLowerText.SetLabel ('  %d' % (connChoices[num]['conn']['min']))
        self.connUpperText.SetLabel ('%d' % (connChoices[num]['conn']['max']))
        self.onConnScroll (0)
        self.onRateScroll (0)

        self.config['max_initiate'] = connChoices[num].get('initiate', 40)


    def about(self, event):
        if (self.aboutBox is not None):
            try:
                self.aboutBox.Close ()
            except wxPyDeadObjectError, e:
                self.aboutBox = None

        self.aboutBox = wxFrame(None, -1, 'About BitTorrent', size = (1,1))
        if (sys.platform == 'win32'):
            self.aboutBox.SetIcon(self.icon)

        panel = wxPanel(self.aboutBox, -1)
        colSizer = wxFlexGridSizer(cols = 1, vgap = 3)

        titleSizer = wxBoxSizer(wxHORIZONTAL)
        aboutTitle = wxStaticText(panel, -1, 'BitTorrent ' + version)
        aboutTitle.SetFont(wxFont(14, wxDEFAULT, wxNORMAL, wxNORMAL, false))
        titleSizer.Add (aboutTitle)
        linkDonate = wxStaticText(panel, -1, 'Donate to Bram\n(link)', style = wxALIGN_RIGHT)
        linkDonate.SetForegroundColour('Blue');
        linkDonate.SetFont(wxFont(-1, wxDEFAULT, wxNORMAL, wxNORMAL, true))
        titleSizer.Add (linkDonate, 1, wxALIGN_BOTTOM&wxEXPAND)
        colSizer.Add(titleSizer, 0, wxEXPAND)

        colSizer.Add(wxStaticText(panel, -1, 'created by Bram Cohen, Copyright 2001-2003,'))
        colSizer.Add(wxStaticText(panel, -1, 'experimental version maintained by John Hoffman 2003'))
        colSizer.Add(wxStaticText(panel, -1, 'modified from experimental version by Eike Frost 2003'))
        credits = wxStaticText(panel, -1, 'full credits\n')
        credits.SetForegroundColour('Blue');
        credits.SetFont(wxFont(-1, wxDEFAULT, wxNORMAL, wxNORMAL, true))
        colSizer.Add(credits);

        systemInformation = wxStaticText(panel, -1,
          'exact Version String: ' + version + '\n'+
          'Python version: ' + sys.version + '\n')
        colSizer.Add(systemInformation)

        babble1 = wxStaticText(panel, -1,
         'This is an experimental, unofficial build of BitTorrent.\n' +
         'It is Free Software under an MIT-Style license.')
        babble2 = wxStaticText(panel, -1,'BitTorrent Homepage (link)')
        babble2.SetForegroundColour('Blue');
        babble2.SetFont(wxFont(-1, wxDEFAULT, wxNORMAL, wxNORMAL, true))
        babble3 = wxStaticText(panel, -1,"TheSHAD0W's Client Homepage (link)")
        babble3.SetForegroundColour('Blue');
        babble3.SetFont(wxFont(-1, wxDEFAULT, wxNORMAL, wxNORMAL, true))
        babble4 = wxStaticText(panel, -1,"Eike Frost's Client Homepage (link)")
        babble4.SetForegroundColour('Blue');
        babble4.SetFont(wxFont(-1, wxDEFAULT, wxNORMAL, wxNORMAL, true))
        babble6 = wxStaticText(panel, -1, 'License Terms (link)')
        babble6.SetForegroundColour('Blue');
        babble6.SetFont(wxFont(-1, wxDEFAULT, wxNORMAL, wxNORMAL, true))
        colSizer.Add (babble1)
        colSizer.Add (babble2)
        colSizer.Add (babble3)
        colSizer.Add (babble4)
        colSizer.Add (babble6)

        okButton = wxButton(panel, -1, 'Ok')
        colSizer.Add(okButton, 0, wxALIGN_RIGHT)
        colSizer.AddGrowableCol(0)

        border = wxBoxSizer(wxHORIZONTAL)
        border.Add(colSizer, 1, wxEXPAND | wxALL, 4)
        panel.SetSizer(border)
        panel.SetAutoLayout(true)

        def donatelink(self):
            Thread(target = open_new('https://www.paypal.com/cgi-bin/webscr?cmd=_xclick&business=bram@bitconjurer.org&item_name=BitTorrent&amount=5.00&submit=donate')).start()
        EVT_LEFT_DOWN(linkDonate, donatelink)
        def aboutlink(self):
            Thread(target = open_new('http://bitconjurer.org/BitTorrent/')).start()
        EVT_LEFT_DOWN(babble2, aboutlink)
        def shadlink(self):
            Thread(target = open_new('http://bt.degreez.net/')).start()
        EVT_LEFT_DOWN(babble3, shadlink)
        def explink(self):
            Thread(target = open_new('http://ei.kefro.st/projects/btclient/')).start()
        EVT_LEFT_DOWN(babble4, explink)
        def licenselink(self):
            Thread(target = open_new('http://ei.kefro.st/projects/btclient/LICENSE.TXT')).start()
        EVT_LEFT_DOWN(babble6, licenselink)
        EVT_LEFT_DOWN(credits, self.credits)

        def closeAbout(self, frame = self):
            frame.aboutBox.Close ()
        EVT_BUTTON(self.aboutBox, okButton.GetId(), closeAbout)

        self.aboutBox.Show ()
        border.Fit(panel)
        self.aboutBox.Fit()


    def details(self, event):
        metainfo = self.dow.getResponse()
        announce = metainfo['announce']
        info = metainfo['info']
        info_hash = sha(bencode(info))
        piece_length = info['piece length']

        if (self.detailBox is not None):
            try:
                self.detailBox.Close ()
            except wxPyDeadObjectError, e:
                self.detailBox = None

        self.detailBox = wxFrame(None, -1, 'Torrent Details ', size = wxSize(405,230))
        if (sys.platform == 'win32'):
            self.detailBox.SetIcon(self.icon)

        panel = wxPanel(self.detailBox, -1, size = wxSize (400,220))
        colSizer = wxFlexGridSizer(cols = 1, vgap = 3)
        colSizer.AddGrowableCol(0)

        titleSizer = wxBoxSizer(wxHORIZONTAL)
        aboutTitle = wxStaticText(panel, -1, 'Details about ' + self.filename)
        aboutTitle.SetFont(wxFont(14, wxDEFAULT, wxNORMAL, wxNORMAL, false))
        
        titleSizer.Add (aboutTitle)
        colSizer.Add (titleSizer)

        detailSizer = wxFlexGridSizer(cols = 2, vgap = 6)

        if info.has_key('length'):
            detailSizer.Add(wxStaticText(panel, -1, 'file name :'))
            detailSizer.Add(wxStaticText(panel, -1, info['name']))
            file_length = info['length']
            name = "file size"
        else:
            detail1Sizer = wxFlexGridSizer(cols = 1, vgap = 6)
            detail1Sizer.Add(wxStaticText(panel, -1, 'directory name : ' + info['name']))
            file_length = 0
            list = []
            
            fileList = wxListCtrl(panel, -1, wxPoint(-1,-1), (325,100), wxLC_REPORT)
            fileList.SetAutoLayout (true)
            fileList.InsertColumn(0, "files")

            x = 0
            for file in info['files']:
                path = ''
                for item in file['path']:
                    if (path != ''):
                        path = path + "/"
                    path = path + item
                fileList.InsertStringItem(x, path+' ('+str(file['length'])+')')
                x += 1
                file_length += file['length']
            fileList.SetColumnWidth(0,wxLIST_AUTOSIZE)

            name = 'archive size'
            detail1Sizer.Add(fileList, 1, wxEXPAND)
            detail1Sizer.Add(wxStaticText(panel, -1, ''))
            detail1Sizer.AddGrowableRow(1)
            detail1Sizer.AddGrowableCol(0)
            colSizer.Add (detail1Sizer, 1, wxEXPAND)
            colSizer.AddGrowableRow(1)

        detailSizer.Add(wxStaticText(panel, -1, 'info_hash :'))
        detailSizer.Add(wxTextCtrl(panel, -1, info_hash.hexdigest(), size = (325, -1), style = wxTE_READONLY))
        num_pieces = int(file_length+piece_length-1)/piece_length
        detailSizer.Add(wxStaticText(panel, -1, name + ' : '))
        detailSizer.Add(wxStaticText(panel, -1, '%s (%s bytes)' % (size_format(file_length), comma_format(file_length))))
        detailSizer.Add(wxStaticText(panel, -1, 'pieces : '))
        detailSizer.Add(wxStaticText(panel, -1, '%i (%s bytes each)' % (num_pieces, comma_format(piece_length))))
        detailSizer.Add(wxStaticText(panel, -1, 'announce url : '))
        detailSizer.Add(wxTextCtrl(panel, -1, announce, size = (325, -1), style = wxTE_READONLY))
        detailSizer.Add(wxStaticText(panel, -1, 'likely tracker :'))
        p = re.compile( '(.*/)[^/]+')
        turl = p.sub (r'\1', announce)
        trackerUrl = wxStaticText(panel, -1, turl)
        trackerUrl.SetForegroundColour('Blue');
        trackerUrl.SetFont(wxFont(-1, wxDEFAULT, wxNORMAL, wxNORMAL, true))
        detailSizer.Add(trackerUrl)
        if info.has_key('comment'):
            detailSizer.Add(wxStaticText(panel, -1, 'comment :'))
            detailSizer.Add(wxStaticText(panel, -1, info['comment']))
        if info.has_key('creation date'):
            detailSizer.Add(wxStaticText(panel, -1, 'creation date :'))
            detailSizer.Add(wxStaticText(panel, -1, info['creation date']))

        detailSizer.AddGrowableCol(1)
        colSizer.Add (detailSizer, 1, wxEXPAND)

        okButton = wxButton(panel, -1, 'Ok')
        colSizer.Add(okButton, 0, wxALIGN_RIGHT)
        colSizer.AddGrowableCol(0)

        if not self.configfile.configfileargs['gui_stretchwindow']:
            aboutTitle.SetSize((400,-1))
        else:
            panel.SetAutoLayout(true)

        border = wxBoxSizer(wxHORIZONTAL)
        border.Add(colSizer, 1, wxEXPAND | wxALL, 4)
        panel.SetSizer(border)
        panel.SetAutoLayout(true)

        def closeDetail(self, frame = self):
            frame.detailBox.Close ()
        EVT_BUTTON(self.detailBox, okButton.GetId(), closeDetail)

        def trackerurl(self, turl = turl):
            Thread(target = open_new(turl)).start()

        EVT_LEFT_DOWN(trackerUrl, trackerurl)

        self.detailBox.Show ()
        border.Fit(panel)
        self.detailBox.Fit()

    def credits(self, event):
        if (self.creditsBox is not None):
            try:
                self.creditsBox.Close ()
            except wxPyDeadObjectError, e:
                self.creditsBox = None

        self.creditsBox = wxFrame(None, -1, 'Credits', size = (1,1))
        if (sys.platform == 'win32'):
            self.creditsBox.SetIcon(self.icon)

        panel = wxPanel(self.creditsBox, -1)        
        colSizer = wxFlexGridSizer(cols = 1, vgap = 3)

        titleSizer = wxBoxSizer(wxHORIZONTAL)
        aboutTitle = wxStaticText(panel, -1, 'Credits')
        aboutTitle.SetFont(wxFont(14, wxDEFAULT, wxNORMAL, wxNORMAL, false))
        titleSizer.Add (aboutTitle)
        colSizer.Add (titleSizer)
        colSizer.Add (wxStaticText(panel, -1,
          'The following people have all helped with this\n' +
          'version of BitTorrent in some way (in no particular order) -\n'));
        creditSizer = wxFlexGridSizer(cols = 3)
        creditSizer.Add(wxStaticText(panel, -1,
          'Bill Bumgarner\n' +
          'David Creswick\n' +
          'Andrew Loewenstern\n' +
          'Ross Cohen\n' +
          'Jeremy Avnet\n' +
          'Greg Broiles\n' +
          'Barry Cohen\n' +
          'Bram Cohen\n' +
          'sayke\n' +
          'Steve Jenson\n' +
          'Myers Carpenter\n' +
          'Francis Crick\n' +
          'Petru Paler\n' +
          'Jeff Darcy\n' +
          'John Gilmore\n'))
        creditSizer.Add(wxStaticText(panel, -1, '  '))
        creditSizer.Add(wxStaticText(panel, -1,
          'Yann Vernier\n' +
          'Pat Mahoney\n' +
          'Boris Zbarsky\n' +
          'Eric Tiedemann\n' +
          'Henry "Pi" James\n' +
          'Loring Holden\n' +
          'Robert Stone\n' +
          'Michael Janssen\n' +
          'Eike Frost\n' +
          'Andrew Todd\n' +
          'otaku\n' +
          'Edward Keyes\n' +
          'John Hoffman\n'))
        colSizer.Add (creditSizer, flag = wxALIGN_CENTER_HORIZONTAL)
        okButton = wxButton(panel, -1, 'Ok')
        colSizer.Add(okButton, 0, wxALIGN_RIGHT)
        colSizer.AddGrowableCol(0)

        border = wxBoxSizer(wxHORIZONTAL)
        border.Add(colSizer, 1, wxEXPAND | wxALL, 4)
        panel.SetSizer(border)
        panel.SetAutoLayout(true)

        def closeCredits(self, frame = self):
            frame.creditsBox.Close ()
        EVT_BUTTON(self.creditsBox, okButton.GetId(), closeCredits)

        self.creditsBox.Show ()
        border.Fit(panel)
        self.creditsBox.Fit()


    def statusIconHelp(self, event):
        if (self.statusIconHelpBox is not None):
            try:
                self.statusIconHelpBox.Close ()
            except wxPyDeadObjectError, e:
                self.statusIconHelpBox = None

        self.statusIconHelpBox = wxFrame(None, -1, 'Help with the BitTorrent Status Light', size = (1,1))
        if (sys.platform == 'win32'):
            self.statusIconHelpBox.SetIcon(self.icon)

        panel = wxPanel(self.statusIconHelpBox, -1)
        fullsizer = wxFlexGridSizer(cols = 1, vgap = 13)
        colsizer = wxFlexGridSizer(cols = 2, hgap = 13, vgap = 13)

        disconnectedicon=self.createStatusIcon('disconnected')
        colsizer.Add(wxStaticBitmap(panel, -1, disconnectedicon))
        colsizer.Add(wxStaticText(panel, -1,
            'Waiting to connect to the tracker.\n' +
            'If the status light stays black for a long time the tracker\n' +
            'you are trying to connect to may not be working.  Unless you\n' +
            'are receiving a message telling you otherwise, please wait,\n' +
            'and BitTorrent will automatically try to reconnect for you.'), 1, wxALIGN_CENTER_VERTICAL)
        
        noconnectionsicon=self.createStatusIcon('noconnections')
        colsizer.Add(wxStaticBitmap(panel, -1, noconnectionsicon))
        colsizer.Add(wxStaticText(panel, -1,
            'You have no connections with other clients.\n' +
            'Please be patient.  If after several minutes the status\n' +
            'light remains red, this torrent may be old and abandoned.'), 1, wxALIGN_CENTER_VERTICAL)

        nocompletesicon=self.createStatusIcon('nocompletes')
        colsizer.Add(wxStaticBitmap(panel, -1, nocompletesicon))
        colsizer.Add(wxStaticText(panel, -1,
            'There are no complete copies among the clients you are\n' +
            'connected to.  Don\'t panic, other clients in the torrent\n' +
            "you can't see may have the missing data.\n" +
            'If the status light remains blue, you may have problems\n' +
            'completing your download.'), 1, wxALIGN_CENTER_VERTICAL)

        noincomingicon=self.createStatusIcon('noincoming')
        colsizer.Add(wxStaticBitmap(panel, -1, noincomingicon))
        colsizer.Add(wxStaticText(panel, -1,
            'You have not received any incoming connections from others.\n' +
            'It may only be because no one has tried.  If you never see\n' +
            'the status light turn green, it may indicate your system\n' +
            'is behind a firewall or proxy server.  Please look into\n' +
            'routing BitTorrent through your firewall in order to receive\n' +
            'the best possible download rate.'), 1, wxALIGN_CENTER_VERTICAL)

        allgoodicon=self.createStatusIcon('allgood')
        colsizer.Add(wxStaticBitmap(panel, -1, allgoodicon))
        colsizer.Add(wxStaticText(panel, -1,
            'The torrent is operating properly.'), 1, wxALIGN_CENTER_VERTICAL)

        fullsizer.Add(colsizer, 0, wxALIGN_CENTER)
        colsizer2 = wxFlexGridSizer(cols = 1, hgap = 13)

        colsizer2.Add(wxStaticText(panel, -1,
            'Please note that the status light is not omniscient, and that it may\n' +
            'be wrong in many instances.  A torrent with a blue light may complete\n' +
            "normally, and an occasional yellow light doesn't mean your computer\n" +
            'has suddenly become firewalled.'), 1, wxALIGN_CENTER_VERTICAL)

        colspacer = wxStaticText(panel, -1, '  ', style = wxALIGN_RIGHT)
        colsizer2.Add(colspacer)

        okButton = wxButton(panel, -1, 'Ok')
        colsizer2.Add(okButton, 0, wxALIGN_CENTER)
        fullsizer.Add(colsizer2, 0, wxALIGN_CENTER)

        border = wxBoxSizer(wxHORIZONTAL)
        border.Add(fullsizer, 1, wxEXPAND | wxALL, 4)
        
        panel.SetSizer(border)
        panel.SetAutoLayout(true)


        def closeHelp(self, frame = self):
            frame.statusIconHelpBox.Close ()
        EVT_BUTTON(self.statusIconHelpBox, okButton.GetId(), closeHelp)

        self.statusIconHelpBox.Show ()
        border.Fit(panel)
        self.statusIconHelpBox.Fit()


    def openConfigMenu(self, event):
        self.configfile.configMenu()


    def advanced(self, event):
        if (self.advBox is not None):
            try:
                self.advBox.Close ()
            except wxPyDeadObjectError, e:
                self.advBox = None

        self.advBox = wxFrame(None, -1, 'BitTorrent Advanced', size = wxSize(200,200))
        if (sys.platform == 'win32'):
            self.advBox.SetIcon(self.icon)

        panel = wxPanel(self.advBox, -1, size = wxSize (200,200))

        colSizer = wxBoxSizer (wxVERTICAL)
        colSizer.Add (wxStaticText(panel, -1, 'Advanced Info for ' + self.filename))
        spewList = wxListCtrl(panel, -1, wxPoint(-1,-1), (590,450), wxLC_REPORT|wxLC_HRULES|wxLC_VRULES)
        spewList.SetAutoLayout (true)

        colSizer.Add(spewList, -1, wxEXPAND)

        buttonSizer = wxFlexGridSizer (cols = 3, hgap = 20)

        reannounceButton = wxButton(panel, -1, 'Initiate Manual Announce')
        buttonSizer.Add (reannounceButton)

        bgallocButton = wxButton(panel, -1, 'Finish Allocation')
        buttonSizer.Add (bgallocButton)

        okButton = wxButton(panel, -1, 'Ok')
        buttonSizer.Add (okButton, -1, wxALIGN_RIGHT)

        colSizer.Add (buttonSizer)
        colSizer.SetMinSize ((578,400))

        panel.SetSizer(colSizer)
        panel.SetAutoLayout(true)

        self.spewList = spewList
        spewList.InsertColumn(0, "optimistic unchoke", width=18)
        spewList.InsertColumn(1, "IP", width=100)
        spewList.InsertColumn(2, "local/remote", width=18)
        spewList.InsertColumn(3, "Up", format=wxLIST_FORMAT_RIGHT, width=55)
        spewList.InsertColumn(4, "Interested", width=18)
        spewList.InsertColumn(5, "Choking", width=18)
        spewList.InsertColumn(6, "Down", format=wxLIST_FORMAT_RIGHT, width=55)
        spewList.InsertColumn(7, "Interesting", width=18)
        spewList.InsertColumn(8, "Choked", width=18)
        spewList.InsertColumn(9, "Snubbed", width=18)
        spewList.InsertColumn(10, "Downloaded", format=wxLIST_FORMAT_RIGHT, width=65)
        spewList.InsertColumn(11, "Uploaded", format=wxLIST_FORMAT_RIGHT, width=65)
        spewList.InsertColumn(12, "Completed", format=wxLIST_FORMAT_RIGHT, width=55)
        spewList.InsertColumn(13, "Peer Download Speed", format=wxLIST_FORMAT_RIGHT, width=55)

        def closeAdv(self, frame = self):
            frame.advBox.Close ()
        def killAdv(self, frame = self):
            frame.advBox.Destroy()
            frame.advBox = None
        EVT_BUTTON(self.advBox, okButton.GetId(), closeAdv)
        EVT_CLOSE(self.advBox, killAdv)

        def reannounce(self, frame = self):
            if (time () - frame.reannouncelast > 60):
                frame.reannouncelast = time ()
                frame.dow.reannounce()
        EVT_BUTTON(self.advBox, reannounceButton.GetId(), reannounce)

        def bgalloc(self, frame = self):
            if frame.dow.storagewrapper is not None:
                frame.dow.storagewrapper.bgalloc()
        EVT_BUTTON(self.advBox, bgallocButton.GetId(), bgalloc)

        self.advBox.Show ()
        colSizer.Fit(panel)
        self.advBox.Fit()


    def displayUsage(self, text):
        start = self.dow.getUsageText()
        if text[:len(start)] != start:
            return false

        self.done(None)
        self.usageBox = wxFrame(None, -1, 'Usage', size = (480,400))
        if (sys.platform == 'win32'):
            self.usageBox.SetIcon(self.icon)

        panel = wxScrolledWindow(self.usageBox, -1)
        colSizer = wxFlexGridSizer(cols = 1)

        colSizer.Add (wxStaticText(panel, -1, text))
        okButton = wxButton(panel, -1, 'Ok')
        colSizer.Add(okButton, 0, wxALIGN_RIGHT)
        colSizer.AddGrowableCol(0)


        def closeUsage(self, frame = self):
            frame.usageBox.Close()
        EVT_BUTTON(self.usageBox, okButton.GetId(), closeUsage)

        self.usageBox.Show ()
        panel.FitInside()
        panel.SetSizer(colSizer)
        panel.SetAutoLayout(true)
        panel.SetScrollRate(0,1)
        self.usageBox.Fit()

        return true        

        
    def onInvoke(self, event):
        if not self.uiflag.isSet():
            apply(event.func, event.args, event.kwargs)

    def invokeLater(self, func, args = [], kwargs = {}):
        if not self.uiflag.isSet():
            wxPostEvent(self.frame, InvokeEvent(func, args, kwargs))

    def updateStatus(self, fractionDone = None,
            timeEst = None, downRate = None, upRate = None,
            activity = None, statistics = None, spew = None, sizeDone = None,
            **kws):
        if activity is not None:
            self.activity = activity
        if not self.ispaused:
            self.invokeLater(self.onUpdateStatus,
                     [fractionDone, timeEst, downRate, upRate, statistics, spew, sizeDone])

    def onUpdateStatus(self, fractionDone, timeEst, downRate, upRate, statistics, spew, sizeDone):
        if self.gui_lastupdate + 0.01 > time():   # refreshing wayyyy too fast, skip it
            return

        if self.firstupdate:
            self.connChoice.SetStringSelection(self.configfile.configfileargs['gui_ratesettingsdefault'])
            self.onConnChoice(0)         # force config selection for default value
            self.gauge.SetForegroundColour(self.configfile.checkingcolor)
            self.firstupdate = false

        if statistics is None:
            self.setStatusIcon('startup')
        elif statistics.numPeers + statistics.numSeeds + statistics.numOldSeeds == 0:
            if statistics.last_failed:
                self.setStatusIcon('disconnected')
            else:
                self.setStatusIcon('noconnections')
        elif (statistics.numSeeds + statistics.numOldSeeds == 0) and (statistics.numCopies < 1):
            self.setStatusIcon('nocompletes')
        elif (statistics.external_connection_made or
                  self.configfile.configfileargs['gui_forcegreenonfirewall']):
            self.setStatusIcon('allgood')
        else:
            self.setStatusIcon('noincoming')

        if self.updateSliderFlag == 1:
          self.updateSliderFlag = 0
          newValue = (self.rateSpinner.GetValue()
                       / connChoices[self.connChoice.GetSelection()]['rate'].get('div',1))
          if self.rateslider.GetValue() != newValue:
              self.rateslider.SetValue(newValue)

        if self.updateSpinnerFlag == 1:
          self.updateSpinnerFlag = 0
          newValue = (self.rateslider.GetValue()
                       * connChoices[self.connChoice.GetSelection()]['rate'].get('div',1))
          if self.rateSpinner.GetValue() != newValue:
              self.rateSpinner.SetValue(newValue)
        if self.fin:
            if statistics is not None:
                if statistics.numOldSeeds > 0 or statistics.numCopies > 1:
                    self.gauge.SetValue(1000)
                else:
                    self.gauge.SetValue(int(1000*statistics.numCopies))
        elif fractionDone is not None:
            gaugelevel = int(fractionDone * 1000)
            self.gauge.SetValue(gaugelevel)
            if statistics is not None and statistics.downTotal is not None:
                if self.configfile.configfileargs['gui_displaymiscstats']:
                    self.frame.SetTitle('%.1f%% (%.2f MiB) %s - BitTorrent %s' % (float(gaugelevel)/10, float(sizeDone) / (1<<20), self.filename, version))
                else:
                    self.frame.SetTitle('%.1f%% %s - BitTorrent %s' % (float(gaugelevel)/10, self.filename, version))
                self.gauge.SetForegroundColour(self.configfile.downloadcolor)
            else:
                self.frame.SetTitle('%.0f%% %s - BitTorrent %s' % (float(gaugelevel)/10, self.filename, version))
        if timeEst is not None:
            self.timeText.SetLabel(hours(time () - self.starttime) + ' / ' + hours(timeEst))
        else:
            if self.fin:
                self.timeText.SetLabel(self.activity)
            else:
                self.timeText.SetLabel(hours(time () - self.starttime) + ' / ' + self.activity)
        if downRate is not None:
            self.downRateText.SetLabel('%.0f kB/s' % (float(downRate) / 1000))
        if upRate is not None:
            self.upRateText.SetLabel('%.0f kB/s' % (float(upRate) / 1000))
        if hasattr(self.frame, "tbicon"):
            icontext='BitTorrent '
            if fractionDone is not None and not self.fin:
                icontext=icontext+' %.1f%% (%.2f MiB)' % (fractionDone*100, float(sizeDone) / (1<<20))
            if upRate is not None:
                icontext=icontext+' u:%.0f kB/s' % (float(upRate) / 1000)
            if downRate is not None:
                icontext=icontext+' d:%.0f kB/s' % (float(downRate) / 1000)
            icontext+=' %s' % self.filename
            self.frame.tbicon.SetIcon(self.icon,icontext)
        if statistics is not None:
            if self.configfile.configfileargs['gui_displaymiscstats']:
                self.downText.SetLabel('%.2f MiB' % (float(statistics.downTotal) / (1 << 20)))
                self.upText.SetLabel('%.2f MiB' % (float(statistics.upTotal) / (1 << 20)))
            if (statistics.shareRating < 0) or (statistics.shareRating > 1000):
                self.shareRatingText.SetLabel('oo :-D')
                self.shareRatingText.SetForegroundColour('Forest Green')
            else:
                shareSmiley = ''
                color = 'Black'
                if ((statistics.shareRating >= 0) and (statistics.shareRating < 0.5)):
                    shareSmiley = ':-('
                    color = 'Red'
                else:
                    if ((statistics.shareRating >= 0.5) and (statistics.shareRating < 1.0)):
                        shareSmiley = ':-|'
                        color = 'Orange'
                    else:
                        if (statistics.shareRating >= 1.0):
                            shareSmiley = ':-)'
                            color = 'Forest Green'
                self.shareRatingText.SetLabel('%.3f %s' % (statistics.shareRating, shareSmiley))
                self.shareRatingText.SetForegroundColour(color)

            if self.configfile.configfileargs['gui_displaystats']:
                if not self.fin:
                   self.seedStatusText.SetLabel('connected to %d seeds; also seeing %.3f distributed copies' % (statistics.numSeeds,0.001*int(1000*statistics.numCopies)))
                else:
                   self.seedStatusText.SetLabel('%d seeds seen recently; also seeing %.3f distributed copies' % (statistics.numOldSeeds,0.001*int(1000*statistics.numCopies)))
                self.peerStatusText.SetLabel('connected to %d peers with an average of %.1f%% completed (total speed %.0f kB/s)' % (statistics.numPeers,statistics.percentDone,float(statistics.torrentRate) / (1000)))
        if ((time () - self.lastError) > 300):
            self.errorText.SetLabel('')

        if ( self.configfile.configfileargs['gui_displaymiscstats']
            and self.dow.storagewrapper is not None and self.dow.storagewrapper.bgalloc_active ):
            self.bgalloc_periods += 1
            if self.bgalloc_periods > 3:
                self.bgalloc_periods = 0
            self.bgallocText.SetLabel('allocating'+('.'*self.bgalloc_periods))
        else:
            self.bgallocText.SetLabel('')

            
        if spew is not None and (time()-self.spewwait>1):
            if (self.advBox is not None):
               self.spewwait = time()
               spewList = self.spewList
               if (spewList.GetItemCount()-(len(spew)+2)) < 0:
                 for x in range(len(spew)+2-spewList.GetItemCount()):
                   spewList.InsertStringItem(x,'')
               if (spewList.GetItemCount()+2-len(spew)) > 0:
                 for x in range(len(spew)+2,spewList.GetItemCount()):
                   spewList.DeleteItem(x)

               tot_uprate = 0.0
               tot_downrate = 0.0
               for x in range(len(spew)):
                   if (spew[x]['optimistic'] == 1):
                       a = '*'
                   else:
                       a = ' '
                   spewList.SetStringItem(x, 0, a)
                   spewList.SetStringItem(x, 1, spew[x]['ip'])
                   spewList.SetStringItem(x, 2, spew[x]['direction'])
                   if spew[x]['uprate'] > 100:
                       spewList.SetStringItem(x, 3, '%.0f kB/s' % (float(spew[x]['uprate']) / 1000))
                   else:
                       spewList.SetStringItem(x, 3, ' ')
                   tot_uprate += spew[x]['uprate']
                   if (spew[x]['uinterested'] == 1):
                       a = '*'
                   else:
                       a = ' '
                   spewList.SetStringItem(x, 4, a)
                   if (spew[x]['uchoked'] == 1):
                       a = '*'
                   else:
                       a = ' '
                   spewList.SetStringItem(x, 5, a)

                   if spew[x]['downrate'] > 100:
                       spewList.SetStringItem(x, 6, '%.0f kB/s' % (float(spew[x]['downrate']) / 1000))
                   else:
                       spewList.SetStringItem(x, 6, ' ')
                   tot_downrate += spew[x]['downrate']

                   if (spew[x]['dinterested'] == 1):
                       a = '*'
                   else:
                       a = ' '
                   spewList.SetStringItem(x, 7, a)
                   if (spew[x]['dchoked'] == 1):
                       a = '*'
                   else:
                       a = ' '
                   spewList.SetStringItem(x, 8, a)
                   if (spew[x]['snubbed'] == 1):
                       a = '*'
                   else:
                       a = ' '
                   spewList.SetStringItem(x, 9, a)
                   spewList.SetStringItem(x, 10, '%.2f MiB' % (float(spew[x]['dtotal']) / (1 << 20)))
                   spewList.SetStringItem(x, 11, '%.2f MiB' % (float(spew[x]['utotal']) / (1 << 20)))
                   spewList.SetStringItem(x, 12, '%.1f%%' % (float(int(spew[x]['completed']*1000))/10))
                   spewList.SetStringItem(x, 13, '%.0f kB/s' % (float(spew[x]['speed']) / 1000))

               x = len(spew)                   
               spewList.SetStringItem(x, 0, '')
               spewList.SetStringItem(x, 1, '')
               spewList.SetStringItem(x, 2, '')
               spewList.SetStringItem(x, 3, '')
               spewList.SetStringItem(x, 4, '')
               spewList.SetStringItem(x, 5, '')
               spewList.SetStringItem(x, 6, '')
               spewList.SetStringItem(x, 7, '')
               spewList.SetStringItem(x, 8, '')
               spewList.SetStringItem(x, 9, '')
               spewList.SetStringItem(x, 10, '')
               spewList.SetStringItem(x, 11, '')
               spewList.SetStringItem(x, 12, '')
               spewList.SetStringItem(x, 13, '')

               x += 1               
               spewList.SetStringItem(x, 0, '')
               spewList.SetStringItem(x, 1, '         TOTALS:')
               spewList.SetStringItem(x, 2, '')
               spewList.SetStringItem(x, 3, '%.0f kB/s' % (float(tot_uprate) / 1000))
               spewList.SetStringItem(x, 4, '')
               spewList.SetStringItem(x, 5, '')
               spewList.SetStringItem(x, 6, '%.0f kB/s' % (float(tot_downrate) / 1000))
               spewList.SetStringItem(x, 7, '')
               spewList.SetStringItem(x, 8, '')
               spewList.SetStringItem(x, 9, '')
               if statistics is not None:
                   spewList.SetStringItem(x, 10, '%.2f MiB' % (float(statistics.downTotal) / (1 << 20)))
                   spewList.SetStringItem(x, 11, '%.2f MiB' % (float(statistics.upTotal) / (1 << 20)))
               else:
                   spewList.SetStringItem(x, 10, '')
                   spewList.SetStringItem(x, 11, '')
               spewList.SetStringItem(x, 12, '')
               spewList.SetStringItem(x, 13, '')


        if self.configfile.configReset:     # whoopee!  Set everything invisible! :-)
            self.configfile.configReset = false
            
            statsdisplayflag = self.configfile.configfileargs['gui_displaymiscstats']
            self.downTextLabel.Show(statsdisplayflag)
            self.upTextLabel.Show(statsdisplayflag)
            self.fileDestLabel.Show(statsdisplayflag)
            self.fileDestText.Show(statsdisplayflag)
            self.colSizer.Layout()
            
            self.downText.SetLabel('')          # blank these to flush them
            self.upText.SetLabel('')
            self.seedStatusText.SetLabel('')
            self.peerStatusText.SetLabel('')
            
            ratesettingsmode = self.configfile.configfileargs['gui_ratesettingsmode']
            ratesettingsflag1 = true    #\ settings
            ratesettingsflag2 = false   #/ for 'basic'
            if ratesettingsmode == 'none':
                ratesettingsflag1 = false
            elif ratesettingsmode == 'full':
                ratesettingsflag2 = true
            self.connChoiceLabel.Show(ratesettingsflag1)
            self.connChoice.Show(ratesettingsflag1)
            self.rateSpinnerLabel.Show(ratesettingsflag2)
            self.rateSpinner.Show(ratesettingsflag2)
            self.rateLowerText.Show(ratesettingsflag2)
            self.rateUpperText.Show(ratesettingsflag2)
            self.rateslider.Show(ratesettingsflag2)
            self.connSpinnerLabel.Show(ratesettingsflag2)
            self.connSpinner.Show(ratesettingsflag2)
            self.connLowerText.Show(ratesettingsflag2)
            self.connUpperText.Show(ratesettingsflag2)
            self.connslider.Show(ratesettingsflag2)
            self.unlimitedLabel.Show(ratesettingsflag2)

            if statistics is None or statistics.downTotal is None:
                self.gauge.SetForegroundColour(self.configfile.checkingcolor)
                self.gauge.SetBackgroundColour(wx.wxSystemSettings_GetColour(wxSYS_COLOUR_MENU))
            elif self.fin:
                self.gauge.SetForegroundColour(self.configfile.seedingcolor)
                self.gauge.SetBackgroundColour(self.configfile.downloadcolor)
            else:
                self.gauge.SetForegroundColour(self.configfile.downloadcolor)
                self.gauge.SetBackgroundColour(wx.wxSystemSettings_GetColour(wxSYS_COLOUR_MENU))

            self.frame.Layout()
            self.frame.Refresh()

        self.gui_lastupdate = time()
 

    def finished(self):
        self.fin = true
        self.invokeLater(self.onFinishEvent)

    def failed(self):
        self.fin = true
        self.invokeLater(self.onFailEvent)

    def error(self, errormsg):
        self.invokeLater(self.onErrorEvent, [errormsg])

    def onFinishEvent(self):
        self.activity = hours(time () - self.starttime) + ' / ' +'Download Succeeded!'
        self.cancelButton.SetLabel('Finish')
        self.gauge.SetBackgroundColour(self.configfile.downloadcolor)
        self.gauge.SetValue(0)
        self.gauge.SetForegroundColour(self.configfile.seedingcolor)
        self.frame.SetTitle('%s - Upload - BitTorrent %s' % (self.filename, version))
        if (sys.platform == 'win32'):
            self.icon = wxIcon(os.path.join(basepath,'icon_done.ico'), wxBITMAP_TYPE_ICO)
            self.frame.SetIcon(self.icon)
        if hasattr(self.frame, "tbicon"):
                self.frame.tbicon.SetIcon(self.icon, "BitTorrent - Finished")
        self.downRateText.SetLabel('')

    def onFailEvent(self):
        if not self.shuttingdown:
            self.timeText.SetLabel(hours(time () - self.starttime) + ' / ' +'Failed!')
            self.activity = 'Failed!'
            self.cancelButton.SetLabel('Close')
            self.gauge.SetValue(0)
            self.downRateText.SetLabel('')

    def onErrorEvent(self, errormsg):
        if not self.displayUsage(errormsg):
            self.errorText.SetLabel(strftime('ERROR (%I:%M %p) -\n') + errormsg)
            self.lastError = time ()


    def chooseFile(self, default, size, saveas, dir):
        f = Event()
        bucket = [None]
        self.invokeLater(self.onChooseFile, [default, bucket, f, size, dir, saveas])
        f.wait()
        return bucket[0]
    
    def onChooseFile(self, default, bucket, f, size, dir, saveas):
        if saveas == '':
            if self.configfile.configfileargs['gui_default_savedir'] != '':
                start_dir = self.configfile.configfileargs['gui_default_savedir']
            else:
                start_dir = self.configfile.configfileargs['last_saved']
            if not isdir(start_dir):    # if it's not set properly
                start_dir = '/'    # yes, this hack does work in Windows
            if dir:
                if isdir(join(start_dir,default)):
                    start_dir = join(start_dir,default)
                dl = wxDirDialog(self.frame,
                        'Choose a directory to save to, pick a partial download to resume',
                        defaultPath = start_dir, style = wxDD_DEFAULT_STYLE | wxDD_NEW_DIR_BUTTON)
            else:
                dl = wxFileDialog(self.frame,
                        'Choose file to save as, pick a partial download to resume', 
                        defaultDir = start_dir, defaultFile = default, wildcard = '*.*',
                        style = wxSAVE)

            if dl.ShowModal() != wxID_OK:
                f.set()
                self.done(None)
                return
            
            d = dl.GetPath()
            bucket[0] = d
            d1,d2 = split(d)
            if d2 == default:
                d = d1
            self.configfile.WriteLastSaved(d)
            
        else:
            bucket[0] = saveas
            default = basename(saveas)

        self.fileNameText.SetLabel('%s' % (default))
        self.fileSizeText.SetLabel('(%.2f MiB)' % (float(size) / (1 << 20)))
        self.timeText.SetLabel(hours(time () - self.starttime) + ' / ' + self.activity)
        self.fileDestText.SetLabel(bucket[0])
        self.filename = default
        self.frame.SetTitle(default + '- BitTorrent ' + version)
        f.set()

        minsize = self.fileNameText.GetBestSize()
        if (not self.configfile.configfileargs['gui_stretchwindow'] or
                            minsize.GetWidth() < self.addwidth):
            minsize.SetWidth(self.addwidth)
        self.fnsizer.SetMinSize (minsize)
        minsize.SetHeight(self.fileSizeText.GetBestSize().GetHeight())
        self.fnsizer2.SetMinSize (minsize)
        minsize.SetWidth(minsize.GetWidth()+(self.fnspacer.GetBestSize().GetWidth())+42)
        minsize.SetHeight(self.fileNameText.GetBestSize().GetHeight()+self.fileSizeText.GetBestSize().GetHeight())
        minsize.SetHeight(2*self.errorText.GetBestSize().GetHeight())
        self.errorTextSizer.SetMinSize(minsize)
        self.topboxsizer.SetMinSize(minsize)

        # Kludge to make details and about catch the event
        self.frame.SetSize ((self.frame.GetSizeTuple()[0]+1, self.frame.GetSizeTuple()[1]+1))
        self.frame.SetSize ((self.frame.GetSizeTuple()[0]-1, self.frame.GetSizeTuple()[1]-1))
        self.colSizer.Fit(self.frame)

    def newpath(self, path):
        self.fileDestText.SetLabel(path)

    def pause(self, event):
        self.invokeLater(self.onPause)

    def onPause(self):
        if self.ispaused:
            self.ispaused = false
            self.pauseButton.SetLabel('Pause')
            self.dow.Unpause()
        else:
            self.ispaused = true
            self.dow.Pause()
            self.pauseButton.SetLabel('Resume')
            self.downRateText.SetLabel(' ')
            self.upRateText.SetLabel(' ')
            self.seedStatusText.SetLabel(' ')
            self.peerStatusText.SetLabel(' ')
            self.setStatusIcon('startup')

    def done(self, event):
        self.uiflag.set()
        self.shuttingdown = true
        if hasattr(self.frame, "tbicon"):
            self.frame.tbicon.Destroy()
            del self.frame.tbicon
        self.flag.set()
        if self.ispaused:
            self.dow.Unpause()
        if (self.detailBox is not None):
            try:
                self.detailBox.Close ()
            except wxPyDeadObjectError, e:
                self.detailBox = None
        if (self.aboutBox is not None):
            try:
                self.aboutBox.Close ()
            except wxPyDeadObjectError, e:
                self.aboutBox = None
        if (self.creditsBox is not None):
            try:
                self.creditsBox.Close ()
            except wxPyDeadObjectError, e:
                self.creditsBox = None
        if (self.advBox is not None):
            try:
                self.advBox.Close ()
            except wxPyDeadObjectError, e:
                self.advBox = None
                
        if (self.statusIconHelpBox is not None):
            try:
                self.statusIconHelpBox.Close ()
            except wxPyDeadObjectError, e:
                self.statusIconHelpBox = None
        self.configfile.Close()
        self.frame.Destroy()


class btWxApp(wxApp):
    def __init__(self, x, params):
        self.params = params
        wxApp.__init__(self, x)

    def OnInit(self):
        doneflag = Event()
        d = DownloadInfoFrame(doneflag)
        self.SetTopWindow(d.frame)
        if len(self.params) == 0:
            b = wxFileDialog (d.frame, 'Choose .torrent file to use',
                        defaultDir = '', defaultFile = '', wildcard = '*.torrent',
                        style = wxOPEN)
            if b.ShowModal() == wxID_OK:
                self.params.append (b.GetPath())

        thread = Thread(target = next, args = [self.params, d, doneflag])
        thread.setDaemon(false)
        thread.start()
        return 1

def run(params):
    app = btWxApp(0, params)
    app.MainLoop()

def next(params, d, doneflag):
    dow = Download ()
    d.dow = dow
    configfile = configReader(dow.getDefaults())
    d.configfile = configfile
    d.configfileargs = d.configfile.configfileargs
    dow.download(params, d.chooseFile, d.updateStatus, d.finished, d.error, doneflag, 100, d.newpath, d.configfileargs)
    if not d.fin:
        d.failed()

if __name__ == '__main__':
    run(argv[1:])
